/* bit.c declares data for the bit.h macros to utilise
 *
 * written nml 2003-05-07
 *
 */

#include "firstinclude.h"

#include "bit.h"

#include <limits.h>

unsigned long int bit_lbits[] = {
    0, 0x1, 0x3, 0x7, 0xf, 0x1f, 0x3f, 0x7f, 0xff, 0x1ff, 0x3ff, 0x7ff, 
    0xfff, 0x1fff, 0x3fff, 0x7fff, 0xffff, 0x1ffff, 0x3ffff, 0x7ffff, 
    0xfffff, 0x1fffff, 0x3fffff, 0x7fffff, 0xffffff, 0x1ffffff, 0x3ffffff, 
    0x7ffffff, 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff, 0xffffffff
#if (0xffffffffffffffffUL <= ULONG_MAX)
    , 0x1ffffffffUL, 0x3ffffffffUL, 0x7ffffffffUL, 0xfffffffffUL, 
    0x1fffffffffUL, 0x3fffffffffUL, 0x7fffffffffUL, 0xffffffffffUL, 
    0x1ffffffffffUL, 0x3ffffffffffUL, 0x7ffffffffffUL, 0xfffffffffffUL, 
    0x1fffffffffffUL, 0x3fffffffffffUL, 0x7fffffffffffUL, 0xffffffffffffUL, 
    0x1ffffffffffffUL, 0x3ffffffffffffUL, 0x7ffffffffffffUL, 0xfffffffffffffUL,
    0x1fffffffffffffUL, 0x3fffffffffffffUL, 0x7fffffffffffffUL, 
    0xffffffffffffffUL, 0x1ffffffffffffffUL, 0x3ffffffffffffffUL, 
    0x7ffffffffffffffUL, 0xfffffffffffffffUL, 0x1fffffffffffffffUL, 
    0x3fffffffffffffffUL, 0x7fffffffffffffffUL, 0xffffffffffffffffUL
#elif (0xffffffffffffffffUL < ULONG_MAX)
#error "bit.h not > 64 bit ready"
#endif
};

unsigned char bit_revbits[] = {
    0x0, 0x80, 0x40, 0xc0, 0x20, 0xa0, 0x60, 0xe0, 0x10, 0x90, 0x50, 0xd0, 
    0x30, 0xb0, 0x70, 0xf0, 0x8, 0x88, 0x48, 0xc8, 0x28, 0xa8, 0x68, 0xe8, 
    0x18, 0x98, 0x58, 0xd8, 0x38, 0xb8, 0x78, 0xf8, 0x4, 0x84, 0x44, 0xc4, 
    0x24, 0xa4, 0x64, 0xe4, 0x14, 0x94, 0x54, 0xd4, 0x34, 0xb4, 0x74, 0xf4, 
    0xc, 0x8c, 0x4c, 0xcc, 0x2c, 0xac, 0x6c, 0xec, 0x1c, 0x9c, 0x5c, 0xdc, 
    0x3c, 0xbc, 0x7c, 0xfc, 0x2, 0x82, 0x42, 0xc2, 0x22, 0xa2, 0x62, 0xe2, 
    0x12, 0x92, 0x52, 0xd2, 0x32, 0xb2, 0x72, 0xf2, 0xa, 0x8a, 0x4a, 0xca, 
    0x2a, 0xaa, 0x6a, 0xea, 0x1a, 0x9a, 0x5a, 0xda, 0x3a, 0xba, 0x7a, 0xfa, 
    0x6, 0x86, 0x46, 0xc6, 0x26, 0xa6, 0x66, 0xe6, 0x16, 0x96, 0x56, 0xd6, 
    0x36, 0xb6, 0x76, 0xf6, 0xe, 0x8e, 0x4e, 0xce, 0x2e, 0xae, 0x6e, 0xee, 
    0x1e, 0x9e, 0x5e, 0xde, 0x3e, 0xbe, 0x7e, 0xfe, 0x1, 0x81, 0x41, 0xc1, 
    0x21, 0xa1, 0x61, 0xe1, 0x11, 0x91, 0x51, 0xd1, 0x31, 0xb1, 0x71, 0xf1, 
    0x9, 0x89, 0x49, 0xc9, 0x29, 0xa9, 0x69, 0xe9, 0x19, 0x99, 0x59, 0xd9, 
    0x39, 0xb9, 0x79, 0xf9, 0x5, 0x85, 0x45, 0xc5, 0x25, 0xa5, 0x65, 0xe5, 
    0x15, 0x95, 0x55, 0xd5, 0x35, 0xb5, 0x75, 0xf5, 0xd, 0x8d, 0x4d, 0xcd, 
    0x2d, 0xad, 0x6d, 0xed, 0x1d, 0x9d, 0x5d, 0xdd, 0x3d, 0xbd, 0x7d, 0xfd, 
    0x3, 0x83, 0x43, 0xc3, 0x23, 0xa3, 0x63, 0xe3, 0x13, 0x93, 0x53, 0xd3, 
    0x33, 0xb3, 0x73, 0xf3, 0xb, 0x8b, 0x4b, 0xcb, 0x2b, 0xab, 0x6b, 0xeb, 
    0x1b, 0x9b, 0x5b, 0xdb, 0x3b, 0xbb, 0x7b, 0xfb, 0x7, 0x87, 0x47, 0xc7, 
    0x27, 0xa7, 0x67, 0xe7, 0x17, 0x97, 0x57, 0xd7, 0x37, 0xb7, 0x77, 0xf7, 
    0xf, 0x8f, 0x4f, 0xcf, 0x2f, 0xaf, 0x6f, 0xef, 0x1f, 0x9f, 0x5f, 0xdf, 
    0x3f, 0xbf, 0x7f, 0xff
};

unsigned int bit_log2(unsigned long int num) {
    unsigned int i = 1,
                 bits = BIT_FROM_BYTE(sizeof(unsigned long int));

    while ((i < bits) && !(num & BIT_UMASK(i))) {
        i++;
    }

    return bits - i;
}

unsigned int bit_rev(unsigned int src, unsigned int byte_width) {
    unsigned int dst,
                 i;

    switch (byte_width) {
    case 1:
        dst = bit_revbits[src];
        break;

    case 2:
        dst = (bit_revbits[src & BIT_LMASK(8)] << 8)
              | bit_revbits[src >> 8];
        break;

    case 4:
        dst = (bit_revbits[(src >> 0) & BIT_LMASK(8)] << 24)
              | (bit_revbits[(src >> 8) & BIT_LMASK(8)] << 16)
              | (bit_revbits[(src >> 16) & BIT_LMASK(8)] << 8)
              | (bit_revbits[(src >> 24) & BIT_LMASK(8)] << 0);
        break;

#if (0xffffffffffffffff <= UINT_MAX)
    case 8:
        dst = (bit_revbits[(src >> 0) & BIT_LMASK(8)] << 56)
              | (bit_revbits[(src >> 8) & BIT_LMASK(8)] << 48)
              | (bit_revbits[(src >> 16) & BIT_LMASK(8)] << 40)
              | (bit_revbits[(src >> 24) & BIT_LMASK(8)] << 32)
              | (bit_revbits[(src >> 32) & BIT_LMASK(8)] << 24)
              | (bit_revbits[(src >> 40) & BIT_LMASK(8)] << 16)
              | (bit_revbits[(src >> 48) & BIT_LMASK(8)] << 8)
              | (bit_revbits[(src >> 56) & BIT_LMASK(8)] << 0);
        break;
#endif

    default:
        dst = 0;
        for (i = 0; i < sizeof(dst); i++) {
            dst |= bit_revbits[(src >> BIT_FROM_BYTE(i)) & BIT_LMASK(8)]
              << BIT_FROM_BYTE(sizeof(dst) - (i + 1));
        }
    }
    return dst;
}

unsigned int bit_set(unsigned int var, unsigned int bit, unsigned int val) {
    return BIT_SET(var, bit, val);
}

unsigned int bit_toggle(unsigned int var, unsigned int bit) {
    return BIT_TOGGLE(var, bit);
}

unsigned int bit_get(unsigned int var, unsigned int bit) {
    return BIT_GET(var, bit);
}

unsigned int bit_mul2(unsigned int num, unsigned int pow) {
    return BIT_MUL2(num, pow);
}

unsigned int bit_div2(unsigned int num, unsigned int pow) {
    return BIT_DIV2(num, pow);
}

unsigned int bit_mod2(unsigned int num, unsigned int pow) {
    return BIT_MOD2(num, pow);
}

unsigned int bit_pow2(unsigned int pow) {
    return BIT_POW2(pow);
}

unsigned int bit_umask(unsigned int bits) {
    return BIT_UMASK(bits);
}

unsigned int bit_lmask(unsigned int bits) {
    return BIT_LMASK(bits);
}

void bit_array_null(void *arr, unsigned int nmemb, unsigned int width) {
    memset(arr, 0, nmemb * width);
}

unsigned int bit_to_byte(unsigned int bits) {
    return BIT_TO_BYTE(bits);
}

unsigned int bit_from_byte(unsigned int bits) {
    return BIT_FROM_BYTE(bits);
}

#ifdef BIT_TEST
#include <stdio.h>
#include <stdlib.h>
int main() {
    printf("log2 0 %u 1 %u 2 %u UINT_MAX %u\n", bit_log2(0), bit_log2(1),
      bit_log2(2), bit_log2(UINT_MAX));
    return EXIT_SUCCESS;
}
#endif

