/* mime.h provides support for MIME types as originally proposed 
 * by RFCs 1521 and 1522, and updated by RFCs 2045 through 2049.
 * It provides enumerations for convenient representation of 
 * recognised MIME types, as well as a functions for determining
 * MIME types for given MIME names and file contents.
 *
 * DO NOT modify this file, as it is automatically generated 
 * and changes will be lost upon subsequent regeneration.
 *
 * It is automatically generated from media-type files describing 
 * valid MIME types by scripts/mime.py.  The definitive list can be found at 
 * http://www.isi.edu/in-notes/iana/assignments/media-types/media-types, 
 * although scripts/mime.py will accept multiple files (in the same format), 
 * allowing you to define your own MIME types as convenient.
 *
 * This file was generated on Wed, 03 May 2006 07:26:21 +0000 
 * by scripts/mime.py
 *
 */

#ifndef MIME_H
#define MIME_H

#ifdef _cplusplus
extern "C" {
#endif

enum mime_top_types {
    MIME_TOP_TYPE_APPLICATION = 0,
    MIME_TOP_TYPE_AUDIO = 1,
    MIME_TOP_TYPE_CHEMICAL = 2,
    MIME_TOP_TYPE_IMAGE = 3,
    MIME_TOP_TYPE_MESSAGE = 4,
    MIME_TOP_TYPE_MODEL = 5,
    MIME_TOP_TYPE_MULTIPART = 6,
    MIME_TOP_TYPE_TEXT = 7,
    MIME_TOP_TYPE_VIDEO = 8,
    MIME_TOP_TYPE_X_CONFERENCE = 9,
    MIME_TOP_TYPE_ERR = -1
};

/* numbered so that (hopefully) commonly used MIME types have 
   low numbers */
enum mime_types {
    MIME_TYPE_APPLICATION_ACTIVEMESSAGE = 223,
    MIME_TYPE_APPLICATION_ANDREW_INSET = 204,
    MIME_TYPE_APPLICATION_APPLEFILE = 149,
    MIME_TYPE_APPLICATION_ATOMICMAIL = 165,
    MIME_TYPE_APPLICATION_BATCH_SMTP = 166,
    MIME_TYPE_APPLICATION_BEEP_XML = 136,
    MIME_TYPE_APPLICATION_CALS_1840 = 150,
    MIME_TYPE_APPLICATION_COMMONGROUND = 205,
    MIME_TYPE_APPLICATION_CYBERCASH = 151,
    MIME_TYPE_APPLICATION_DCA_RFT = 119,
    MIME_TYPE_APPLICATION_DEC_DX = 105,
    MIME_TYPE_APPLICATION_DVCS = 83,
    MIME_TYPE_APPLICATION_EDIFACT = 118,
    MIME_TYPE_APPLICATION_EDI_CONSENT = 183,
    MIME_TYPE_APPLICATION_EDI_X12 = 117,
    MIME_TYPE_APPLICATION_ESHOP = 97,
    MIME_TYPE_APPLICATION_FONT_TDPFR = 167,
    MIME_TYPE_APPLICATION_HTTP = 84,
    MIME_TYPE_APPLICATION_HYPERSTUDIO = 184,
    MIME_TYPE_APPLICATION_IGES = 85,
    MIME_TYPE_APPLICATION_INDEX = 98,
    MIME_TYPE_APPLICATION_INDEX_CMD = 152,
    MIME_TYPE_APPLICATION_INDEX_OBJ = 153,
    MIME_TYPE_APPLICATION_INDEX_RESPONSE = 241,
    MIME_TYPE_APPLICATION_INDEX_VND = 154,
    MIME_TYPE_APPLICATION_IOTP = 86,
    MIME_TYPE_APPLICATION_IPP = 73,
    MIME_TYPE_APPLICATION_ISUP = 87,
    MIME_TYPE_APPLICATION_MACWRITEII = 168,
    MIME_TYPE_APPLICATION_MAC_BINHEX40 = 206,
    MIME_TYPE_APPLICATION_MAC_COMPACTPRO = 461,
    MIME_TYPE_APPLICATION_MARC = 88,
    MIME_TYPE_APPLICATION_MATHEMATICA = 31,
    MIME_TYPE_APPLICATION_MATHEMATICA_OLD = 471,
    MIME_TYPE_APPLICATION_MSWORD = 24,
    MIME_TYPE_APPLICATION_NEWS_MESSAGE_ID = 254,
    MIME_TYPE_APPLICATION_NEWS_TRANSMISSION = 282,
    MIME_TYPE_APPLICATION_OCSP_REQUEST = 207,
    MIME_TYPE_APPLICATION_OCSP_RESPONSE = 224,
    MIME_TYPE_APPLICATION_OCTET_STREAM = 32,
    MIME_TYPE_APPLICATION_ODA = 74,
    MIME_TYPE_APPLICATION_OGG = 406,
    MIME_TYPE_APPLICATION_PARITYFEC = 155,
    MIME_TYPE_APPLICATION_PDF = 17,
    MIME_TYPE_APPLICATION_PGP_ENCRYPTED = 225,
    MIME_TYPE_APPLICATION_PGP_KEYS = 137,
    MIME_TYPE_APPLICATION_PGP_SIGNATURE = 226,
    MIME_TYPE_APPLICATION_PKCS10 = 106,
    MIME_TYPE_APPLICATION_PKCS7_MIME = 169,
    MIME_TYPE_APPLICATION_PKCS7_SIGNATURE = 255,
    MIME_TYPE_APPLICATION_PKIXCMP = 120,
    MIME_TYPE_APPLICATION_PKIX_CERT = 156,
    MIME_TYPE_APPLICATION_PKIX_CRL = 138,
    MIME_TYPE_APPLICATION_POSTSCRIPT = 30,
    MIME_TYPE_APPLICATION_PRS_ALVESTRAND_TITRAX_SHEET = 369,
    MIME_TYPE_APPLICATION_PRS_CWW = 121,
    MIME_TYPE_APPLICATION_PRS_NPREND = 170,
    MIME_TYPE_APPLICATION_QSIG = 89,
    MIME_TYPE_APPLICATION_REMOTE_PRINTING = 256,
    MIME_TYPE_APPLICATION_RISCOS = 107,
    MIME_TYPE_APPLICATION_RTF = 75,
    MIME_TYPE_APPLICATION_SDP = 76,
    MIME_TYPE_APPLICATION_SET_PAYMENT = 185,
    MIME_TYPE_APPLICATION_SET_PAYMENT_INITIATION = 333,
    MIME_TYPE_APPLICATION_SET_REGISTRATION = 270,
    MIME_TYPE_APPLICATION_SET_REGISTRATION_INITIATION = 370,
    MIME_TYPE_APPLICATION_SGML = 90,
    MIME_TYPE_APPLICATION_SGML_OPEN_CATALOG = 283,
    MIME_TYPE_APPLICATION_SIEVE = 99,
    MIME_TYPE_APPLICATION_SLATE = 100,
    MIME_TYPE_APPLICATION_SMIL = 412,
    MIME_TYPE_APPLICATION_TIMESTAMP_QUERY = 257,
    MIME_TYPE_APPLICATION_TIMESTAMP_REPLY = 258,
    MIME_TYPE_APPLICATION_VEMMI = 101,
    MIME_TYPE_APPLICATION_VND_3M_POST_IT_NOTES = 322,
    MIME_TYPE_APPLICATION_VND_ACCPAC_SIMPLY_ASO = 329,
    MIME_TYPE_APPLICATION_VND_ACCPAC_SIMPLY_IMP = 330,
    MIME_TYPE_APPLICATION_VND_ACUCOBOL = 208,
    MIME_TYPE_APPLICATION_VND_AETHER_IMP = 243,
    MIME_TYPE_APPLICATION_VND_ANSER_WEB_CERTIFICATE_ISSUE_INITIATION = 389,
    MIME_TYPE_APPLICATION_VND_ANSER_WEB_FUNDS_TRANSFER_INITIATION = 388,
    MIME_TYPE_APPLICATION_VND_AUDIOGRAPH = 244,
    MIME_TYPE_APPLICATION_VND_BMI = 122,
    MIME_TYPE_APPLICATION_VND_BUSINESSOBJECTS = 305,
    MIME_TYPE_APPLICATION_VND_CANON_CPDL = 245,
    MIME_TYPE_APPLICATION_VND_CANON_LIPS = 246,
    MIME_TYPE_APPLICATION_VND_CLAYMORE = 209,
    MIME_TYPE_APPLICATION_VND_COMMERCE_BATTELLE = 480,
    MIME_TYPE_APPLICATION_VND_COMMONSPACE = 259,
    MIME_TYPE_APPLICATION_VND_COMSOCALLER = 260,
    MIME_TYPE_APPLICATION_VND_CONTACT_CMSG = 271,
    MIME_TYPE_APPLICATION_VND_COSMOCALLER = 472,
    MIME_TYPE_APPLICATION_VND_CTC_POSML = 227,
    MIME_TYPE_APPLICATION_VND_CUPS_POSTSCRIPT = 306,
    MIME_TYPE_APPLICATION_VND_CUPS_RASTER = 261,
    MIME_TYPE_APPLICATION_VND_CUPS_RAW = 210,
    MIME_TYPE_APPLICATION_VND_CYBANK = 171,
    MIME_TYPE_APPLICATION_VND_DNA = 123,
    MIME_TYPE_APPLICATION_VND_DPGRAPH = 186,
    MIME_TYPE_APPLICATION_VND_DXR = 124,
    MIME_TYPE_APPLICATION_VND_ECDIS_UPDATE = 272,
    MIME_TYPE_APPLICATION_VND_ECOWIN_CHART = 273,
    MIME_TYPE_APPLICATION_VND_ECOWIN_FILEREQUEST = 334,
    MIME_TYPE_APPLICATION_VND_ECOWIN_FILEUPDATE = 331,
    MIME_TYPE_APPLICATION_VND_ECOWIN_SERIES = 284,
    MIME_TYPE_APPLICATION_VND_ECOWIN_SERIESREQUEST = 350,
    MIME_TYPE_APPLICATION_VND_ECOWIN_SERIESUPDATE = 344,
    MIME_TYPE_APPLICATION_VND_ENLIVEN = 187,
    MIME_TYPE_APPLICATION_VND_EPSON_ESF = 228,
    MIME_TYPE_APPLICATION_VND_EPSON_MSF = 229,
    MIME_TYPE_APPLICATION_VND_EPSON_QUICKANIME = 323,
    MIME_TYPE_APPLICATION_VND_EPSON_SALT = 247,
    MIME_TYPE_APPLICATION_VND_EPSON_SSF = 230,
    MIME_TYPE_APPLICATION_VND_ERICSSON_QUICKCALL = 335,
    MIME_TYPE_APPLICATION_VND_EUDORA_DATA = 262,
    MIME_TYPE_APPLICATION_VND_FDF = 125,
    MIME_TYPE_APPLICATION_VND_FFSNS = 157,
    MIME_TYPE_APPLICATION_VND_FLOGRAPHIT = 242,
    MIME_TYPE_APPLICATION_VND_FRAMEMAKER = 248,
    MIME_TYPE_APPLICATION_VND_FSC_WEBLAUNCH = 285,
    MIME_TYPE_APPLICATION_VND_FUJITSU_OASYS = 286,
    MIME_TYPE_APPLICATION_VND_FUJITSU_OASYS2 = 296,
    MIME_TYPE_APPLICATION_VND_FUJITSU_OASYS3 = 297,
    MIME_TYPE_APPLICATION_VND_FUJITSU_OASYSGP = 307,
    MIME_TYPE_APPLICATION_VND_FUJITSU_OASYSPRS = 324,
    MIME_TYPE_APPLICATION_VND_FUJIXEROX_DDD = 287,
    MIME_TYPE_APPLICATION_VND_FUJIXEROX_DOCUWORKS = 345,
    MIME_TYPE_APPLICATION_VND_FUJIXEROX_DOCUWORKS_BINDER = 380,
    MIME_TYPE_APPLICATION_VND_FUT_MISNET = 249,
    MIME_TYPE_APPLICATION_VND_GRAFEQ = 172,
    MIME_TYPE_APPLICATION_VND_GROOVE_ACCOUNT = 298,
    MIME_TYPE_APPLICATION_VND_GROOVE_IDENTITY_MESSAGE = 371,
    MIME_TYPE_APPLICATION_VND_GROOVE_INJECTOR = 308,
    MIME_TYPE_APPLICATION_VND_GROOVE_TOOL_MESSAGE = 346,
    MIME_TYPE_APPLICATION_VND_GROOVE_TOOL_TEMPLATE = 351,
    MIME_TYPE_APPLICATION_VND_GROOVE_VCARD = 274,
    MIME_TYPE_APPLICATION_VND_HHE_LESSON_PLAYER = 332,
    MIME_TYPE_APPLICATION_VND_HP_HPGL = 188,
    MIME_TYPE_APPLICATION_VND_HP_HPID = 189,
    MIME_TYPE_APPLICATION_VND_HP_HPS = 174,
    MIME_TYPE_APPLICATION_VND_HP_PCL = 173,
    MIME_TYPE_APPLICATION_VND_HP_PCLXL = 211,
    MIME_TYPE_APPLICATION_VND_HTTPHONE = 212,
    MIME_TYPE_APPLICATION_VND_HZN_3D_CROSSWORD = 325,
    MIME_TYPE_APPLICATION_VND_IBM_AFPLINEDATA = 309,
    MIME_TYPE_APPLICATION_VND_IBM_MINIPAY = 263,
    MIME_TYPE_APPLICATION_VND_IBM_MODCAP = 250,
    MIME_TYPE_APPLICATION_VND_INFORMIX_VISIONARY = 336,
    MIME_TYPE_APPLICATION_VND_INTERCON_FORMNET = 326,
    MIME_TYPE_APPLICATION_VND_INTERTRUST_DIGIBOX = 337,
    MIME_TYPE_APPLICATION_VND_INTERTRUST_NNCP = 310,
    MIME_TYPE_APPLICATION_VND_INTU_QBO = 213,
    MIME_TYPE_APPLICATION_VND_INTU_QFX = 214,
    MIME_TYPE_APPLICATION_VND_IREPOSITORY_PACKAGE_XML = 372,
    MIME_TYPE_APPLICATION_VND_IS_XPR = 175,
    MIME_TYPE_APPLICATION_VND_JAPANNET_DIRECTORY_SERVICE = 381,
    MIME_TYPE_APPLICATION_VND_JAPANNET_JPNSTORE_WAKEUP = 377,
    MIME_TYPE_APPLICATION_VND_JAPANNET_PAYMENT_WAKEUP = 373,
    MIME_TYPE_APPLICATION_VND_JAPANNET_REGISTRATION = 354,
    MIME_TYPE_APPLICATION_VND_JAPANNET_REGISTRATION_WAKEUP = 385,
    MIME_TYPE_APPLICATION_VND_JAPANNET_SETSTORE_WAKEUP = 378,
    MIME_TYPE_APPLICATION_VND_JAPANNET_VERIFICATION = 355,
    MIME_TYPE_APPLICATION_VND_JAPANNET_VERIFICATION_WAKEUP = 386,
    MIME_TYPE_APPLICATION_VND_KOAN = 139,
    MIME_TYPE_APPLICATION_VND_LOTUS_1_2_3 = 264,
    MIME_TYPE_APPLICATION_VND_LOTUS_APPROACH = 299,
    MIME_TYPE_APPLICATION_VND_LOTUS_FREELANCE = 311,
    MIME_TYPE_APPLICATION_VND_LOTUS_NOTES = 265,
    MIME_TYPE_APPLICATION_VND_LOTUS_ORGANIZER = 312,
    MIME_TYPE_APPLICATION_VND_LOTUS_SCREENCAM = 313,
    MIME_TYPE_APPLICATION_VND_LOTUS_WORDPRO = 288,
    MIME_TYPE_APPLICATION_VND_MCD = 126,
    MIME_TYPE_APPLICATION_VND_MEDIASTATION_CDKEY = 338,
    MIME_TYPE_APPLICATION_VND_MERIDIAN_SLINGSHOT = 339,
    MIME_TYPE_APPLICATION_VND_MIF = 127,
    MIME_TYPE_APPLICATION_VND_MINISOFT_HP3000_SAVE = 352,
    MIME_TYPE_APPLICATION_VND_MITSUBISHI_MISTY_GUARD_TRUSTWEB = 387,
    MIME_TYPE_APPLICATION_VND_MOBIUS_DAF = 462,
    MIME_TYPE_APPLICATION_VND_MOBIUS_DIS = 463,
    MIME_TYPE_APPLICATION_VND_MOBIUS_MBK = 464,
    MIME_TYPE_APPLICATION_VND_MOBIUS_MQY = 465,
    MIME_TYPE_APPLICATION_VND_MOBIUS_MSL = 466,
    MIME_TYPE_APPLICATION_VND_MOBIUS_PLC = 467,
    MIME_TYPE_APPLICATION_VND_MOBIUS_TXF = 468,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE = 340,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_ADSI = 374,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_FIS = 362,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_GOTAP = 379,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_KMR = 363,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_TTC = 364,
    MIME_TYPE_APPLICATION_VND_MOTOROLA_FLEXSUITE_WEM = 365,
    MIME_TYPE_APPLICATION_VND_MOZILLA_XUL_XML = 314,
    MIME_TYPE_APPLICATION_VND_MSEQ = 140,
    MIME_TYPE_APPLICATION_VND_MSIGN = 158,
    MIME_TYPE_APPLICATION_VND_MS_ARTGALRY = 266,
    MIME_TYPE_APPLICATION_VND_MS_ASF = 176,
    MIME_TYPE_APPLICATION_VND_MS_EXCEL = 215,
    MIME_TYPE_APPLICATION_VND_MS_LRM = 177,
    MIME_TYPE_APPLICATION_VND_MS_POWERPOINT = 289,
    MIME_TYPE_APPLICATION_VND_MS_PROJECT = 251,
    MIME_TYPE_APPLICATION_VND_MS_TNEF = 190,
    MIME_TYPE_APPLICATION_VND_MS_WORKS = 216,
    MIME_TYPE_APPLICATION_VND_MUSICIAN = 217,
    MIME_TYPE_APPLICATION_VND_MUSIC_NIFF = 252,
    MIME_TYPE_APPLICATION_VND_NETFPX = 178,
    MIME_TYPE_APPLICATION_VND_NOBLENET_DIRECTORY = 341,
    MIME_TYPE_APPLICATION_VND_NOBLENET_SEALER = 315,
    MIME_TYPE_APPLICATION_VND_NOBLENET_WEB = 275,
    MIME_TYPE_APPLICATION_VND_NOVADIGM_EDM = 276,
    MIME_TYPE_APPLICATION_VND_NOVADIGM_EDX = 277,
    MIME_TYPE_APPLICATION_VND_NOVADIGM_EXT = 278,
    MIME_TYPE_APPLICATION_VND_OSA_NETDEPLOY = 290,
    MIME_TYPE_APPLICATION_VND_PALM = 141,
    MIME_TYPE_APPLICATION_VND_PG_FORMAT = 231,
    MIME_TYPE_APPLICATION_VND_PG_OSASLI = 232,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER6 = 291,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER6_S = 316,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER7 = 292,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER75 = 300,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER75_S = 327,
    MIME_TYPE_APPLICATION_VND_POWERBUILDER7_S = 317,
    MIME_TYPE_APPLICATION_VND_PREVIEWSYSTEMS_BOX = 342,
    MIME_TYPE_APPLICATION_VND_PUBLISHARE_DELTA_TREE = 356,
    MIME_TYPE_APPLICATION_VND_PVI_PTID1 = 233,
    MIME_TYPE_APPLICATION_VND_PWG_XHTML_PRINT_XML = 347,
    MIME_TYPE_APPLICATION_VND_RAPID = 159,
    MIME_TYPE_APPLICATION_VND_S3SMS = 160,
    MIME_TYPE_APPLICATION_VND_SEEMAIL = 191,
    MIME_TYPE_APPLICATION_VND_SHANA_INFORMED_FORMDATA = 375,
    MIME_TYPE_APPLICATION_VND_SHANA_INFORMED_FORMTEMPLATE = 383,
    MIME_TYPE_APPLICATION_VND_SHANA_INFORMED_INTERCHANGE = 382,
    MIME_TYPE_APPLICATION_VND_SHANA_INFORMED_PACKAGE = 366,
    MIME_TYPE_APPLICATION_VND_SSS_COD = 192,
    MIME_TYPE_APPLICATION_VND_SSS_DTF = 193,
    MIME_TYPE_APPLICATION_VND_SSS_NTF = 194,
    MIME_TYPE_APPLICATION_VND_STREET_STREAM = 293,
    MIME_TYPE_APPLICATION_VND_SUN_XML_CALC = 473,
    MIME_TYPE_APPLICATION_VND_SUN_XML_CALC_TEMPLATE = 482,
    MIME_TYPE_APPLICATION_VND_SUN_XML_DRAW = 474,
    MIME_TYPE_APPLICATION_VND_SUN_XML_DRAW_TEMPLATE = 483,
    MIME_TYPE_APPLICATION_VND_SUN_XML_IMPRESS = 478,
    MIME_TYPE_APPLICATION_VND_SUN_XML_IMPRESS_TEMPLATE = 486,
    MIME_TYPE_APPLICATION_VND_SUN_XML_MATH = 475,
    MIME_TYPE_APPLICATION_VND_SUN_XML_WRITER = 477,
    MIME_TYPE_APPLICATION_VND_SUN_XML_WRITER_GLOBAL = 484,
    MIME_TYPE_APPLICATION_VND_SUN_XML_WRITER_TEMPLATE = 485,
    MIME_TYPE_APPLICATION_VND_SVD = 128,
    MIME_TYPE_APPLICATION_VND_SWIFTVIEW_ICS = 294,
    MIME_TYPE_APPLICATION_VND_TRISCAPE_MXS = 279,
    MIME_TYPE_APPLICATION_VND_TRUEAPP = 195,
    MIME_TYPE_APPLICATION_VND_TRUEDOC = 196,
    MIME_TYPE_APPLICATION_VND_TVE_TRIGGER = 267,
    MIME_TYPE_APPLICATION_VND_UFDL = 142,
    MIME_TYPE_APPLICATION_VND_UPLANET_ALERT = 295,
    MIME_TYPE_APPLICATION_VND_UPLANET_ALERT_WBXML = 348,
    MIME_TYPE_APPLICATION_VND_UPLANET_BEARER_CHOICE = 357,
    MIME_TYPE_APPLICATION_VND_UPLANET_BEARER_CHOICE_WBXML = 384,
    MIME_TYPE_APPLICATION_VND_UPLANET_CACHEOP = 318,
    MIME_TYPE_APPLICATION_VND_UPLANET_CACHEOP_WBXML = 358,
    MIME_TYPE_APPLICATION_VND_UPLANET_CHANNEL = 319,
    MIME_TYPE_APPLICATION_VND_UPLANET_CHANNEL_WBXML = 359,
    MIME_TYPE_APPLICATION_VND_UPLANET_LIST = 280,
    MIME_TYPE_APPLICATION_VND_UPLANET_LISTCMD = 320,
    MIME_TYPE_APPLICATION_VND_UPLANET_LISTCMD_WBXML = 360,
    MIME_TYPE_APPLICATION_VND_UPLANET_LIST_WBXML = 343,
    MIME_TYPE_APPLICATION_VND_UPLANET_SIGNAL = 301,
    MIME_TYPE_APPLICATION_VND_VCX = 129,
    MIME_TYPE_APPLICATION_VND_VECTORWORKS = 268,
    MIME_TYPE_APPLICATION_VND_VIDSOFT_VIDCONFERENCE = 361,
    MIME_TYPE_APPLICATION_VND_VISIO = 161,
    MIME_TYPE_APPLICATION_VND_VIVIDENCE_SCRIPTFILE = 353,
    MIME_TYPE_APPLICATION_VND_WAP_SIC = 197,
    MIME_TYPE_APPLICATION_VND_WAP_SLC = 198,
    MIME_TYPE_APPLICATION_VND_WAP_WBXML = 234,
    MIME_TYPE_APPLICATION_VND_WAP_WMLC = 218,
    MIME_TYPE_APPLICATION_VND_WAP_WMLSCRIPTC = 302,
    MIME_TYPE_APPLICATION_VND_WEBTURBO = 219,
    MIME_TYPE_APPLICATION_VND_WRQ_HP3000_LABELLED = 349,
    MIME_TYPE_APPLICATION_VND_WT_STF = 179,
    MIME_TYPE_APPLICATION_VND_XARA = 143,
    MIME_TYPE_APPLICATION_VND_XFDL = 144,
    MIME_TYPE_APPLICATION_VND_YELLOWRIVER_CUSTOM_MENU = 376,
    MIME_TYPE_APPLICATION_WHOISPP_QUERY = 235,
    MIME_TYPE_APPLICATION_WHOISPP_RESPONSE = 281,
    MIME_TYPE_APPLICATION_WITA = 91,
    MIME_TYPE_APPLICATION_WORDPERFECT5_1 = 253,
    MIME_TYPE_APPLICATION_X400_BP = 130,
    MIME_TYPE_APPLICATION_XHTML_XML = 444,
    MIME_TYPE_APPLICATION_XML = 77,
    MIME_TYPE_APPLICATION_XML_DTD = 131,
    MIME_TYPE_APPLICATION_XML_EXTERNAL_PARSED_ENTITY = 367,
    MIME_TYPE_APPLICATION_X_BCPIO = 428,
    MIME_TYPE_APPLICATION_X_BITTORRENT = 456,
    MIME_TYPE_APPLICATION_X_BZIP2 = 429,
    MIME_TYPE_APPLICATION_X_CDLINK = 435,
    MIME_TYPE_APPLICATION_X_CHESS_PGN = 450,
    MIME_TYPE_APPLICATION_X_COMPRESS = 445,
    MIME_TYPE_APPLICATION_X_CPIO = 422,
    MIME_TYPE_APPLICATION_X_CSH = 414,
    MIME_TYPE_APPLICATION_X_DIRECTOR = 446,
    MIME_TYPE_APPLICATION_X_DVI = 415,
    MIME_TYPE_APPLICATION_X_FUTURESPLASH = 469,
    MIME_TYPE_APPLICATION_X_GTAR = 423,
    MIME_TYPE_APPLICATION_X_GZIP = 424,
    MIME_TYPE_APPLICATION_X_HDF = 416,
    MIME_TYPE_APPLICATION_X_INEX = 2,
    MIME_TYPE_APPLICATION_X_JAVASCRIPT = 457,
    MIME_TYPE_APPLICATION_X_KCHART = 436,
    MIME_TYPE_APPLICATION_X_KILLUSTRATOR = 470,
    MIME_TYPE_APPLICATION_X_KOAN = 425,
    MIME_TYPE_APPLICATION_X_KPRESENTER = 458,
    MIME_TYPE_APPLICATION_X_KSPREAD = 440,
    MIME_TYPE_APPLICATION_X_KWORD = 430,
    MIME_TYPE_APPLICATION_X_LATEX = 431,
    MIME_TYPE_APPLICATION_X_NETCDF = 437,
    MIME_TYPE_APPLICATION_X_RPM = 417,
    MIME_TYPE_APPLICATION_X_SH = 413,
    MIME_TYPE_APPLICATION_X_SHAR = 426,
    MIME_TYPE_APPLICATION_X_SHOCKWAVE_FLASH = 476,
    MIME_TYPE_APPLICATION_X_STUFFIT = 441,
    MIME_TYPE_APPLICATION_X_SV4CPIO = 442,
    MIME_TYPE_APPLICATION_X_SV4CRC = 438,
    MIME_TYPE_APPLICATION_X_TAR = 33,
    MIME_TYPE_APPLICATION_X_TCL = 418,
    MIME_TYPE_APPLICATION_X_TEX = 419,
    MIME_TYPE_APPLICATION_X_TEXINFO = 443,
    MIME_TYPE_APPLICATION_X_TREC = 3,
    MIME_TYPE_APPLICATION_X_TROFF = 432,
    MIME_TYPE_APPLICATION_X_TROFF_MAN = 451,
    MIME_TYPE_APPLICATION_X_TROFF_ME = 447,
    MIME_TYPE_APPLICATION_X_TROFF_MS = 448,
    MIME_TYPE_APPLICATION_X_USTAR = 433,
    MIME_TYPE_APPLICATION_X_WAIS_SOURCE = 460,
    MIME_TYPE_APPLICATION_ZIP = 18,

    MIME_TYPE_AUDIO_32KADPCM = 67,
    MIME_TYPE_AUDIO_BASIC = 13,
    MIME_TYPE_AUDIO_DAT12 = 395,
    MIME_TYPE_AUDIO_G_722_1 = 399,
    MIME_TYPE_AUDIO_L16 = 390,
    MIME_TYPE_AUDIO_L20 = 391,
    MIME_TYPE_AUDIO_L24 = 392,
    MIME_TYPE_AUDIO_MIDI = 394,
    MIME_TYPE_AUDIO_MP4A_LATM = 407,
    MIME_TYPE_AUDIO_MPA_ROBUST = 92,
    MIME_TYPE_AUDIO_MPEG = 9,
    MIME_TYPE_AUDIO_PARITYFEC = 78,
    MIME_TYPE_AUDIO_PRS_SID = 47,
    MIME_TYPE_AUDIO_TELEPHONE_EVENT = 162,
    MIME_TYPE_AUDIO_TONE = 38,
    MIME_TYPE_AUDIO_VND_CISCO_NSE = 132,
    MIME_TYPE_AUDIO_VND_CNS_ANP1 = 108,
    MIME_TYPE_AUDIO_VND_CNS_INF1 = 109,
    MIME_TYPE_AUDIO_VND_DIGITAL_WINDS = 199,
    MIME_TYPE_AUDIO_VND_EVERAD_PLJ = 145,
    MIME_TYPE_AUDIO_VND_LUCENT_VOICE = 180,
    MIME_TYPE_AUDIO_VND_NORTEL_VBK = 146,
    MIME_TYPE_AUDIO_VND_NUERA_ECELP4800 = 236,
    MIME_TYPE_AUDIO_VND_NUERA_ECELP7470 = 237,
    MIME_TYPE_AUDIO_VND_NUERA_ECELP9600 = 238,
    MIME_TYPE_AUDIO_VND_OCTEL_SBC = 133,
    MIME_TYPE_AUDIO_VND_QCELP = 79,
    MIME_TYPE_AUDIO_VND_RHETOREX_32KADPCM = 269,
    MIME_TYPE_AUDIO_VND_VMX_CVSD = 110,
    MIME_TYPE_AUDIO_X_AIFF = 398,
    MIME_TYPE_AUDIO_X_MPEGURL = 408,
    MIME_TYPE_AUDIO_X_PN_REALAUDIO = 439,
    MIME_TYPE_AUDIO_X_REALAUDIO = 420,
    MIME_TYPE_AUDIO_X_WAV = 396,

    MIME_TYPE_CHEMICAL_X_PDB = 403,
    MIME_TYPE_CHEMICAL_X_XYZ = 404,

    MIME_TYPE_IMAGE_BMP = 393,
    MIME_TYPE_IMAGE_CGM = 34,
    MIME_TYPE_IMAGE_G3FAX = 42,
    MIME_TYPE_IMAGE_GIF = 7,
    MIME_TYPE_IMAGE_IEF = 35,
    MIME_TYPE_IMAGE_JPEG = 10,
    MIME_TYPE_IMAGE_NAPLPS = 43,
    MIME_TYPE_IMAGE_PNG = 8,
    MIME_TYPE_IMAGE_PRS_BTIF = 68,
    MIME_TYPE_IMAGE_PRS_PTI = 48,
    MIME_TYPE_IMAGE_TIFF = 11,
    MIME_TYPE_IMAGE_VND_CNS_INF2 = 111,
    MIME_TYPE_IMAGE_VND_DJVU = 405,
    MIME_TYPE_IMAGE_VND_DWG = 49,
    MIME_TYPE_IMAGE_VND_DXF = 50,
    MIME_TYPE_IMAGE_VND_FASTBIDSHEET = 181,
    MIME_TYPE_IMAGE_VND_FPX = 51,
    MIME_TYPE_IMAGE_VND_FST = 52,
    MIME_TYPE_IMAGE_VND_FUJIXEROX_EDMICS_MMR = 303,
    MIME_TYPE_IMAGE_VND_FUJIXEROX_EDMICS_RLC = 304,
    MIME_TYPE_IMAGE_VND_MIX = 53,
    MIME_TYPE_IMAGE_VND_NET_FPX = 102,
    MIME_TYPE_IMAGE_VND_SVF = 54,
    MIME_TYPE_IMAGE_VND_WAP_WBMP = 112,
    MIME_TYPE_IMAGE_VND_XIFF = 69,
    MIME_TYPE_IMAGE_X_CMU_RASTER = 427,
    MIME_TYPE_IMAGE_X_PORTABLE_ANYMAP = 452,
    MIME_TYPE_IMAGE_X_PORTABLE_BITMAP = 453,
    MIME_TYPE_IMAGE_X_PORTABLE_GRAYMAP = 459,
    MIME_TYPE_IMAGE_X_PORTABLE_PIXMAP = 454,
    MIME_TYPE_IMAGE_X_RGB = 397,
    MIME_TYPE_IMAGE_X_XBITMAP = 409,
    MIME_TYPE_IMAGE_X_XPIXMAP = 410,
    MIME_TYPE_IMAGE_X_XWINDOWDUMP = 434,

    MIME_TYPE_MESSAGE_DELIVERY_STATUS = 200,
    MIME_TYPE_MESSAGE_DISPOSITION_NOTIFICATION = 328,
    MIME_TYPE_MESSAGE_EXTERNAL_BODY = 28,
    MIME_TYPE_MESSAGE_HTTP = 14,
    MIME_TYPE_MESSAGE_NEWS = 44,
    MIME_TYPE_MESSAGE_PARTIAL = 19,
    MIME_TYPE_MESSAGE_RFC822 = 15,
    MIME_TYPE_MESSAGE_S_HTTP = 16,

    MIME_TYPE_MODEL_IGES = 39,
    MIME_TYPE_MODEL_MESH = 40,
    MIME_TYPE_MODEL_VND_DWF = 55,
    MIME_TYPE_MODEL_VND_FLATLAND_3DML = 201,
    MIME_TYPE_MODEL_VND_GDL = 56,
    MIME_TYPE_MODEL_VND_GS_GDL = 93,
    MIME_TYPE_MODEL_VND_GTW = 57,
    MIME_TYPE_MODEL_VND_MTS = 58,
    MIME_TYPE_MODEL_VND_PARASOLID_TRANSMIT_BINARY = 481,
    MIME_TYPE_MODEL_VND_PARASOLID_TRANSMIT_TEXT = 479,
    MIME_TYPE_MODEL_VND_VTU = 59,
    MIME_TYPE_MODEL_VRML = 41,

    MIME_TYPE_MULTIPART_ALTERNATIVE = 29,
    MIME_TYPE_MULTIPART_APPLEDOUBLE = 163,
    MIME_TYPE_MULTIPART_BYTERANGES = 27,
    MIME_TYPE_MULTIPART_DIGEST = 22,
    MIME_TYPE_MULTIPART_ENCRYPTED = 26,
    MIME_TYPE_MULTIPART_FORM_DATA = 134,
    MIME_TYPE_MULTIPART_HEADER_SET = 147,
    MIME_TYPE_MULTIPART_MIXED = 20,
    MIME_TYPE_MULTIPART_PARALLEL = 25,
    MIME_TYPE_MULTIPART_RELATED = 103,
    MIME_TYPE_MULTIPART_REPORT = 94,
    MIME_TYPE_MULTIPART_SIGNED = 23,
    MIME_TYPE_MULTIPART_VOICE_MESSAGE = 202,

    MIME_TYPE_TEXT_CALENDAR = 60,
    MIME_TYPE_TEXT_CSS = 4,
    MIME_TYPE_TEXT_DIRECTORY = 70,
    MIME_TYPE_TEXT_ENRICHED = 61,
    MIME_TYPE_TEXT_HTML = 0,
    MIME_TYPE_TEXT_PARITYFEC = 71,
    MIME_TYPE_TEXT_PLAIN = 1,
    MIME_TYPE_TEXT_PRS_LINES_TAG = 113,
    MIME_TYPE_TEXT_RFC822_HEADERS = 135,
    MIME_TYPE_TEXT_RICHTEXT = 62,
    MIME_TYPE_TEXT_RTF = 5,
    MIME_TYPE_TEXT_SGML = 36,
    MIME_TYPE_TEXT_T140 = 37,
    MIME_TYPE_TEXT_TAB_SEPARATED_VALUES = 239,
    MIME_TYPE_TEXT_URI_LIST = 63,
    MIME_TYPE_TEXT_VND_ABC = 45,
    MIME_TYPE_TEXT_VND_CURL = 64,
    MIME_TYPE_TEXT_VND_DMCLIENTSCRIPT = 203,
    MIME_TYPE_TEXT_VND_FLATLAND_3DML = 449,
    MIME_TYPE_TEXT_VND_FLY = 46,
    MIME_TYPE_TEXT_VND_FMI_FLEXSTOR = 164,
    MIME_TYPE_TEXT_VND_IN3D_3DML = 115,
    MIME_TYPE_TEXT_VND_IN3D_SPOT = 116,
    MIME_TYPE_TEXT_VND_IPTC_NEWSML = 148,
    MIME_TYPE_TEXT_VND_IPTC_NITF = 114,
    MIME_TYPE_TEXT_VND_LATEX_Z = 95,
    MIME_TYPE_TEXT_VND_MOTOROLA_REFLEX = 220,
    MIME_TYPE_TEXT_VND_MS_MEDIAPACKAGE = 221,
    MIME_TYPE_TEXT_VND_WAP_SI = 80,
    MIME_TYPE_TEXT_VND_WAP_SL = 81,
    MIME_TYPE_TEXT_VND_WAP_WML = 96,
    MIME_TYPE_TEXT_VND_WAP_WMLSCRIPT = 182,
    MIME_TYPE_TEXT_XML = 6,
    MIME_TYPE_TEXT_XML_EXTERNAL_PARSED_ENTITY = 321,
    MIME_TYPE_TEXT_X_SETEXT = 400,

    MIME_TYPE_VIDEO_MP4V_ES = 401,
    MIME_TYPE_VIDEO_MPEG = 12,
    MIME_TYPE_VIDEO_PARITYFEC = 82,
    MIME_TYPE_VIDEO_POINTER = 65,
    MIME_TYPE_VIDEO_QUICKTIME = 21,
    MIME_TYPE_VIDEO_VND_FVT = 66,
    MIME_TYPE_VIDEO_VND_MOTOROLA_VIDEO = 222,
    MIME_TYPE_VIDEO_VND_MOTOROLA_VIDEOP = 240,
    MIME_TYPE_VIDEO_VND_MPEGURL = 104,
    MIME_TYPE_VIDEO_VND_MTS = 402,
    MIME_TYPE_VIDEO_VND_NOKIA_INTERLEAVED_MULTIMEDIA = 368,
    MIME_TYPE_VIDEO_VND_VIVO = 72,
    MIME_TYPE_VIDEO_X_MSVIDEO = 411,
    MIME_TYPE_VIDEO_X_SGI_MOVIE = 421,

    MIME_TYPE_X_CONFERENCE_X_COOLTALK = 455,

    MIME_TYPE_UNKNOWN_UNKNOWN = -1
};

/* returns string representation of mime type */
const char *mime_string(enum mime_types mtype);

/* determine which toplevel-type a given mimetype is */
enum mime_top_types mime_top_type(enum mime_types mtype);

/* attempts to hueristically identify MIME types by content, 
 * returns MIME_TYPE_APPLICATION_OCTET_STREAM if unable to do 
 * so. */
enum mime_types mime_content_guess(const void *buf, unsigned int len);

/* returns the mime type indicated by the provided string.  
 * This function probably needs to be turned 
 * into an object accepting a stream at some stage. */
enum mime_types mime_type(const char *str);

#ifdef _cplusplus
}
#endif
          
#endif

